% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllGenerics.R, R/codeml.R, R/hyphy.R, R/paml_rst.R, R/phangorn.R
\docType{methods}
\name{get.subs}
\alias{get.subs}
\alias{get.subs,codeml-method}
\alias{get.subs,hyphy-method}
\alias{get.subs,paml_rst-method}
\alias{get.subs,phangorn-method}
\title{get.subs method}
\usage{
get.subs(object, type, ...)

\S4method{get.subs}{codeml}(object, type, ...)

\S4method{get.subs}{hyphy}(object, type, ...)

\S4method{get.subs}{paml_rst}(object, type, ...)

\S4method{get.subs}{phangorn}(object, type, ...)
}
\arguments{
\item{object}{paml_rst object}

\item{type}{one of 'marginal_subs', 'marginal_AA_subs',
'joint_subs' or 'joint_AA_subs'.}

\item{...}{additional parameter}
}
\value{
data.frame
}
\description{
get substitution information
}
\examples{
nwk <- system.file("extdata/HYPHY", "labelledtree.tree", package="treeio")
ancseq <- system.file("extdata/HYPHY", "ancseq.nex", package="treeio")
tipfas <- system.file("extdata", "pa.fas", package="treeio")
hy <- read.hyphy(nwk, ancseq, tipfas)
get.subs(hy, type="AA_subs")
}

